/* gitg-date.c generated by valac 0.24.0.87-362e, the Vala compiler
 * generated from gitg-date.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2013 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define GITG_TYPE_DATE (gitg_date_get_type ())
#define GITG_DATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GITG_TYPE_DATE, GitgDate))
#define GITG_DATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GITG_TYPE_DATE, GitgDateClass))
#define GITG_IS_DATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GITG_TYPE_DATE))
#define GITG_IS_DATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GITG_TYPE_DATE))
#define GITG_DATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GITG_TYPE_DATE, GitgDateClass))

typedef struct _GitgDate GitgDate;
typedef struct _GitgDateClass GitgDateClass;
typedef struct _GitgDatePrivate GitgDatePrivate;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	GITG_DATE_ERROR_INVALID_FORMAT
} GitgDateError;
#define GITG_DATE_ERROR gitg_date_error_quark ()
struct _GitgDate {
	GObject parent_instance;
	GitgDatePrivate * priv;
};

struct _GitgDateClass {
	GObjectClass parent_class;
};

struct _GitgDatePrivate {
	GDateTime* d_datetime;
	gchar* _date_string;
};


static gpointer gitg_date_parent_class = NULL;
static GRegex* gitg_date_s_rfc2822;
static GRegex* gitg_date_s_rfc2822 = NULL;
static GRegex* gitg_date_s_iso8601;
static GRegex* gitg_date_s_iso8601 = NULL;
static GRegex* gitg_date_s_internal;
static GRegex* gitg_date_s_internal = NULL;
static gchar** gitg_date_s_months;
static gint gitg_date_s_months_length1;
static gchar** gitg_date_s_months = NULL;
static gint gitg_date_s_months_length1 = 0;
static gint _gitg_date_s_months_size_ = 0;
static GInitableIface* gitg_date_g_initable_parent_iface = NULL;

GQuark gitg_date_error_quark (void);
GType gitg_date_get_type (void) G_GNUC_CONST;
#define GITG_DATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GITG_TYPE_DATE, GitgDatePrivate))
enum  {
	GITG_DATE_DUMMY_PROPERTY,
	GITG_DATE_DATE_STRING,
	GITG_DATE_DATE
};
static gboolean gitg_date_fetch_and_set_int (GMatchInfo* info, const gchar* name, gint* retval);
static gboolean gitg_date_fetch_and_set_double (GMatchInfo* info, const gchar* name, gdouble* retval);
static GDateTime* gitg_date_parse_internal (GMatchInfo* info, GError** error);
static GDateTime* gitg_date_parse_iso8601 (GMatchInfo* info, GError** error);
static GDateTime* gitg_date_parse_rfc2822 (GMatchInfo* info, GError** error);
static gboolean gitg_date_real_init (GInitable* base, GCancellable* cancellable, GError** error);
const gchar* gitg_date_get_date_string (GitgDate* self);
GitgDate* gitg_date_new (const gchar* date, GError** error);
GitgDate* gitg_date_construct (GType object_type, const gchar* date, GError** error);
gchar* gitg_date_for_display (GitgDate* self);
GitgDate* gitg_date_new_for_date_time (GDateTime* dt);
GitgDate* gitg_date_construct_for_date_time (GType object_type, GDateTime* dt);
GDateTime* gitg_date_parse (const gchar* date, GError** error);
GDateTime* gitg_date_get_date (GitgDate* self);
void gitg_date_set_date_string (GitgDate* self, const gchar* value);
static void gitg_date_finalize (GObject* obj);
static void _vala_gitg_date_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gitg_date_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GQuark gitg_date_error_quark (void) {
	return g_quark_from_static_string ("gitg_date_error-quark");
}


static gboolean gitg_date_fetch_and_set_int (GMatchInfo* info, const gchar* name, gint* retval) {
	gboolean result = FALSE;
	gchar* val = NULL;
	GMatchInfo* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gint _tmp5_ = 0;
#line 136 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 136 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 138 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = info;
#line 138 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp1_ = name;
#line 138 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp2_ = g_match_info_fetch_named (_tmp0_, _tmp1_);
#line 138 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	val = _tmp2_;
#line 140 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp3_ = val;
#line 140 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	if (_tmp3_ == NULL) {
#line 142 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		result = FALSE;
#line 142 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_free0 (val);
#line 142 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		return result;
#line 149 "gitg-date.c"
	}
#line 145 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp4_ = val;
#line 145 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp5_ = atoi (_tmp4_);
#line 145 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	*retval = _tmp5_;
#line 146 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	result = TRUE;
#line 146 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_free0 (val);
#line 146 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return result;
#line 163 "gitg-date.c"
}


static gdouble double_parse (const gchar* str) {
	gdouble result = 0.0;
	const gchar* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
#line 789 "/opt/gnome/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 790 "/opt/gnome/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 790 "/opt/gnome/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtod (_tmp0_, NULL);
#line 790 "/opt/gnome/share/vala-0.26/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 790 "/opt/gnome/share/vala-0.26/vapi/glib-2.0.vapi"
	return result;
#line 181 "gitg-date.c"
}


static gboolean gitg_date_fetch_and_set_double (GMatchInfo* info, const gchar* name, gdouble* retval) {
	gboolean result = FALSE;
	gchar* val = NULL;
	GMatchInfo* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gdouble _tmp5_ = 0.0;
#line 149 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 149 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 151 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = info;
#line 151 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp1_ = name;
#line 151 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp2_ = g_match_info_fetch_named (_tmp0_, _tmp1_);
#line 151 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	val = _tmp2_;
#line 153 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp3_ = val;
#line 153 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	if (_tmp3_ == NULL) {
#line 155 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		result = FALSE;
#line 155 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_free0 (val);
#line 155 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		return result;
#line 216 "gitg-date.c"
	}
#line 158 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp4_ = val;
#line 158 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp5_ = double_parse (_tmp4_);
#line 158 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	*retval = _tmp5_;
#line 159 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	result = TRUE;
#line 159 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_free0 (val);
#line 159 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return result;
#line 230 "gitg-date.c"
}


static gint64 int64_parse (const gchar* str) {
	gint64 result = 0LL;
	const gchar* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
#line 605 "/opt/gnome/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 606 "/opt/gnome/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 606 "/opt/gnome/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (_tmp0_, NULL, (guint) 0);
#line 606 "/opt/gnome/share/vala-0.26/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 606 "/opt/gnome/share/vala-0.26/vapi/glib-2.0.vapi"
	return result;
#line 248 "gitg-date.c"
}


static GDateTime* gitg_date_parse_internal (GMatchInfo* info, GError** error) {
	GDateTime* result = NULL;
	gchar* timestamp = NULL;
	GMatchInfo* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gint64 unixt = 0LL;
	const gchar* _tmp2_ = NULL;
	gint64 _tmp3_ = 0LL;
	gchar* tzs = NULL;
	GMatchInfo* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
#line 162 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 164 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = info;
#line 164 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp1_ = g_match_info_fetch_named (_tmp0_, "timestamp");
#line 164 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	timestamp = _tmp1_;
#line 165 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp2_ = timestamp;
#line 165 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp3_ = int64_parse (_tmp2_);
#line 165 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	unixt = _tmp3_;
#line 167 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp4_ = info;
#line 167 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp5_ = g_match_info_fetch_named (_tmp4_, "tz");
#line 167 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	tzs = _tmp5_;
#line 169 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp6_ = tzs;
#line 169 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	if (_tmp6_ != NULL) {
#line 288 "gitg-date.c"
		GDateTime* ret = NULL;
		gint64 _tmp7_ = 0LL;
		GDateTime* _tmp8_ = NULL;
		GDateTime* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		GTimeZone* _tmp11_ = NULL;
		GTimeZone* _tmp12_ = NULL;
		GDateTime* _tmp13_ = NULL;
		GDateTime* _tmp14_ = NULL;
#line 171 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp7_ = unixt;
#line 171 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp8_ = g_date_time_new_from_unix_utc (_tmp7_);
#line 171 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		ret = _tmp8_;
#line 172 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp9_ = ret;
#line 172 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp10_ = tzs;
#line 172 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp11_ = g_time_zone_new (_tmp10_);
#line 172 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp12_ = _tmp11_;
#line 172 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp13_ = g_date_time_to_timezone (_tmp9_, _tmp12_);
#line 172 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp14_ = _tmp13_;
#line 172 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_time_zone_unref0 (_tmp12_);
#line 172 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		result = _tmp14_;
#line 172 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_date_time_unref0 (ret);
#line 172 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_free0 (tzs);
#line 172 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_free0 (timestamp);
#line 172 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		return result;
#line 328 "gitg-date.c"
	} else {
		gint64 _tmp15_ = 0LL;
		GDateTime* _tmp16_ = NULL;
#line 176 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp15_ = unixt;
#line 176 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp16_ = g_date_time_new_from_unix_local (_tmp15_);
#line 176 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		result = _tmp16_;
#line 176 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_free0 (tzs);
#line 176 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_free0 (timestamp);
#line 176 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		return result;
#line 344 "gitg-date.c"
	}
#line 162 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_free0 (tzs);
#line 162 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_free0 (timestamp);
#line 350 "gitg-date.c"
}


static GDateTime* gitg_date_parse_iso8601 (GMatchInfo* info, GError** error) {
	GDateTime* result = NULL;
	GTimeZone* tz = NULL;
	GTimeZone* _tmp0_ = NULL;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gdouble seconds = 0.0;
	GMatchInfo* _tmp1_ = NULL;
	GMatchInfo* _tmp2_ = NULL;
	GMatchInfo* _tmp3_ = NULL;
	GMatchInfo* _tmp4_ = NULL;
	GMatchInfo* _tmp5_ = NULL;
	GMatchInfo* _tmp6_ = NULL;
	gchar* tzs = NULL;
	GMatchInfo* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	GTimeZone* _tmp13_ = NULL;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gdouble _tmp19_ = 0.0;
	GDateTime* _tmp20_ = NULL;
#line 180 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 182 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = g_time_zone_new_utc ();
#line 182 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	tz = _tmp0_;
#line 184 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	year = 0;
#line 185 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	month = 1;
#line 186 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	day = 1;
#line 187 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	hour = 0;
#line 188 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	minute = 0;
#line 189 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	seconds = 0.0;
#line 191 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp1_ = info;
#line 191 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (_tmp1_, "year", &year);
#line 192 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp2_ = info;
#line 192 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (_tmp2_, "month", &month);
#line 193 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp3_ = info;
#line 193 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (_tmp3_, "day", &day);
#line 194 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp4_ = info;
#line 194 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (_tmp4_, "hour", &hour);
#line 195 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp5_ = info;
#line 195 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (_tmp5_, "minute", &minute);
#line 196 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp6_ = info;
#line 196 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_double (_tmp6_, "seconds", &seconds);
#line 198 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp7_ = info;
#line 198 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp8_ = g_match_info_fetch_named (_tmp7_, "tz");
#line 198 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	tzs = _tmp8_;
#line 200 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp9_ = tzs;
#line 200 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	if (_tmp9_ != NULL) {
#line 434 "gitg-date.c"
		const gchar* _tmp10_ = NULL;
		GTimeZone* _tmp11_ = NULL;
#line 202 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp10_ = tzs;
#line 202 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp11_ = g_time_zone_new (_tmp10_);
#line 202 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 202 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		tz = _tmp11_;
#line 445 "gitg-date.c"
	} else {
		GTimeZone* _tmp12_ = NULL;
#line 206 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp12_ = g_time_zone_new_local ();
#line 206 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 206 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		tz = _tmp12_;
#line 454 "gitg-date.c"
	}
#line 209 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp13_ = tz;
#line 209 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp14_ = year;
#line 209 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp15_ = month;
#line 209 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp16_ = day;
#line 209 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp17_ = hour;
#line 209 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp18_ = minute;
#line 209 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp19_ = seconds;
#line 209 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp20_ = g_date_time_new (_tmp13_, _tmp14_, _tmp15_, _tmp16_, _tmp17_, _tmp18_, _tmp19_);
#line 209 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	result = _tmp20_;
#line 209 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_free0 (tzs);
#line 209 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_time_zone_unref0 (tz);
#line 209 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return result;
#line 480 "gitg-date.c"
}


static GDateTime* gitg_date_parse_rfc2822 (GMatchInfo* info, GError** error) {
	GDateTime* result = NULL;
	GTimeZone* tz = NULL;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gdouble seconds = 0.0;
	GMatchInfo* _tmp0_ = NULL;
	gchar* monthstr = NULL;
	GMatchInfo* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gint _tmp16_ = 0;
	GMatchInfo* _tmp18_ = NULL;
	GMatchInfo* _tmp19_ = NULL;
	GMatchInfo* _tmp20_ = NULL;
	GMatchInfo* _tmp21_ = NULL;
	gchar* tzs = NULL;
	GMatchInfo* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	const gchar* _tmp24_ = NULL;
	GTimeZone* _tmp28_ = NULL;
	gint _tmp29_ = 0;
	gint _tmp30_ = 0;
	gint _tmp31_ = 0;
	gint _tmp32_ = 0;
	gint _tmp33_ = 0;
	gdouble _tmp34_ = 0.0;
	GDateTime* _tmp35_ = NULL;
	GError * _inner_error_ = NULL;
#line 212 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 215 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	year = 0;
#line 216 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	month = 0;
#line 217 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	day = 1;
#line 218 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	hour = 0;
#line 219 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	minute = 0;
#line 220 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	seconds = (gdouble) 0;
#line 222 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = info;
#line 222 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (_tmp0_, "year", &year);
#line 224 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp1_ = info;
#line 224 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp2_ = g_match_info_fetch_named (_tmp1_, "month");
#line 224 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	monthstr = _tmp2_;
#line 539 "gitg-date.c"
	{
		gint i = 0;
#line 226 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		i = 0;
#line 544 "gitg-date.c"
		{
			gboolean _tmp3_ = FALSE;
#line 226 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_tmp3_ = TRUE;
#line 226 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			while (TRUE) {
#line 551 "gitg-date.c"
				gint _tmp5_ = 0;
				gchar** _tmp6_ = NULL;
				gint _tmp6__length1 = 0;
				gboolean _tmp7_ = FALSE;
				gchar** _tmp8_ = NULL;
				gint _tmp8__length1 = 0;
				gint _tmp9_ = 0;
				const gchar* _tmp10_ = NULL;
#line 226 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				if (!_tmp3_) {
#line 562 "gitg-date.c"
					gint _tmp4_ = 0;
#line 226 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp4_ = i;
#line 226 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					i = _tmp4_ + 1;
#line 568 "gitg-date.c"
				}
#line 226 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp3_ = FALSE;
#line 226 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp5_ = i;
#line 226 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp6_ = gitg_date_s_months;
#line 226 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp6__length1 = gitg_date_s_months_length1;
#line 226 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				if (!(_tmp5_ < _tmp6__length1)) {
#line 226 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					break;
#line 582 "gitg-date.c"
				}
#line 228 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp8_ = gitg_date_s_months;
#line 228 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp8__length1 = gitg_date_s_months_length1;
#line 228 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp9_ = i;
#line 228 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp10_ = _tmp8_[_tmp9_];
#line 228 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				if (_tmp10_ != NULL) {
#line 594 "gitg-date.c"
					gchar** _tmp11_ = NULL;
					gint _tmp11__length1 = 0;
					gint _tmp12_ = 0;
					const gchar* _tmp13_ = NULL;
					const gchar* _tmp14_ = NULL;
#line 228 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp11_ = gitg_date_s_months;
#line 228 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp11__length1 = gitg_date_s_months_length1;
#line 228 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp12_ = i;
#line 228 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp13_ = _tmp11_[_tmp12_];
#line 228 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp14_ = monthstr;
#line 228 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp7_ = g_strcmp0 (_tmp13_, _tmp14_) == 0;
#line 612 "gitg-date.c"
				} else {
#line 228 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp7_ = FALSE;
#line 616 "gitg-date.c"
				}
#line 228 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				if (_tmp7_) {
#line 620 "gitg-date.c"
					gint _tmp15_ = 0;
#line 230 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp15_ = i;
#line 230 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					month = _tmp15_;
#line 231 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					break;
#line 628 "gitg-date.c"
				}
			}
		}
	}
#line 235 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp16_ = month;
#line 235 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	if (_tmp16_ == 0) {
#line 637 "gitg-date.c"
		GError* _tmp17_ = NULL;
#line 237 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp17_ = g_error_new_literal (GITG_DATE_ERROR, GITG_DATE_ERROR_INVALID_FORMAT, "Invalid month specified");
#line 237 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_inner_error_ = _tmp17_;
#line 237 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		g_propagate_error (error, _inner_error_);
#line 237 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_free0 (monthstr);
#line 237 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 237 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		return NULL;
#line 651 "gitg-date.c"
	}
#line 240 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp18_ = info;
#line 240 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (_tmp18_, "day", &day);
#line 241 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp19_ = info;
#line 241 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (_tmp19_, "hour", &hour);
#line 242 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp20_ = info;
#line 242 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (_tmp20_, "minute", &minute);
#line 243 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp21_ = info;
#line 243 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_double (_tmp21_, "seconds", &seconds);
#line 245 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp22_ = info;
#line 245 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp23_ = g_match_info_fetch_named (_tmp22_, "tz");
#line 245 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	tzs = _tmp23_;
#line 247 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp24_ = tzs;
#line 247 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	if (_tmp24_ != NULL) {
#line 679 "gitg-date.c"
		const gchar* _tmp25_ = NULL;
		GTimeZone* _tmp26_ = NULL;
#line 249 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp25_ = tzs;
#line 249 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp26_ = g_time_zone_new (_tmp25_);
#line 249 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 249 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		tz = _tmp26_;
#line 690 "gitg-date.c"
	} else {
		GTimeZone* _tmp27_ = NULL;
#line 253 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp27_ = g_time_zone_new_local ();
#line 253 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 253 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		tz = _tmp27_;
#line 699 "gitg-date.c"
	}
#line 256 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp28_ = tz;
#line 256 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp29_ = year;
#line 256 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp30_ = month;
#line 256 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp31_ = day;
#line 256 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp32_ = hour;
#line 256 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp33_ = minute;
#line 256 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp34_ = seconds;
#line 256 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp35_ = g_date_time_new (_tmp28_, _tmp29_, _tmp30_, _tmp31_, _tmp32_, _tmp33_, _tmp34_);
#line 256 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	result = _tmp35_;
#line 256 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_free0 (tzs);
#line 256 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_free0 (monthstr);
#line 256 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_time_zone_unref0 (tz);
#line 256 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return result;
#line 727 "gitg-date.c"
}


static gboolean gitg_date_real_init (GInitable* base, GCancellable* cancellable, GError** error) {
	GitgDate * self;
	gboolean result = FALSE;
	GMatchInfo* info = NULL;
	GRegex* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GMatchInfo* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GRegex* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	GMatchInfo* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	GRegex* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	GMatchInfo* _tmp18_ = NULL;
	gboolean _tmp19_ = FALSE;
	GError* _tmp24_ = NULL;
	GError * _inner_error_ = NULL;
#line 271 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	self = (GitgDate*) base;
#line 275 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = gitg_date_s_internal;
#line 275 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp1_ = self->priv->_date_string;
#line 275 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp3_ = g_regex_match (_tmp0_, _tmp1_, 0, &_tmp2_);
#line 275 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_match_info_unref0 (info);
#line 275 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	info = _tmp2_;
#line 275 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	if (_tmp3_) {
#line 763 "gitg-date.c"
		GDateTime* _tmp4_ = NULL;
		GMatchInfo* _tmp5_ = NULL;
		GDateTime* _tmp6_ = NULL;
		GDateTime* _tmp7_ = NULL;
#line 277 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp5_ = info;
#line 277 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp6_ = gitg_date_parse_internal (_tmp5_, &_inner_error_);
#line 277 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp4_ = _tmp6_;
#line 277 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 277 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			g_propagate_error (error, _inner_error_);
#line 277 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_g_match_info_unref0 (info);
#line 277 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			return FALSE;
#line 782 "gitg-date.c"
		}
#line 277 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp7_ = _tmp4_;
#line 277 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp4_ = NULL;
#line 277 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_date_time_unref0 (self->priv->d_datetime);
#line 277 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		self->priv->d_datetime = _tmp7_;
#line 279 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		result = TRUE;
#line 279 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_date_time_unref0 (_tmp4_);
#line 279 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_match_info_unref0 (info);
#line 279 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		return result;
#line 800 "gitg-date.c"
	}
#line 282 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp8_ = gitg_date_s_iso8601;
#line 282 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp9_ = self->priv->_date_string;
#line 282 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp11_ = g_regex_match (_tmp8_, _tmp9_, 0, &_tmp10_);
#line 282 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_match_info_unref0 (info);
#line 282 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	info = _tmp10_;
#line 282 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	if (_tmp11_) {
#line 814 "gitg-date.c"
		GDateTime* _tmp12_ = NULL;
		GMatchInfo* _tmp13_ = NULL;
		GDateTime* _tmp14_ = NULL;
		GDateTime* _tmp15_ = NULL;
#line 284 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp13_ = info;
#line 284 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp14_ = gitg_date_parse_iso8601 (_tmp13_, &_inner_error_);
#line 284 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp12_ = _tmp14_;
#line 284 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 284 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			g_propagate_error (error, _inner_error_);
#line 284 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_g_match_info_unref0 (info);
#line 284 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			return FALSE;
#line 833 "gitg-date.c"
		}
#line 284 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp15_ = _tmp12_;
#line 284 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp12_ = NULL;
#line 284 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_date_time_unref0 (self->priv->d_datetime);
#line 284 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		self->priv->d_datetime = _tmp15_;
#line 286 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		result = TRUE;
#line 286 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_date_time_unref0 (_tmp12_);
#line 286 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_match_info_unref0 (info);
#line 286 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		return result;
#line 851 "gitg-date.c"
	}
#line 289 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp16_ = gitg_date_s_rfc2822;
#line 289 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp17_ = self->priv->_date_string;
#line 289 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp19_ = g_regex_match (_tmp16_, _tmp17_, 0, &_tmp18_);
#line 289 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_match_info_unref0 (info);
#line 289 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	info = _tmp18_;
#line 289 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	if (_tmp19_) {
#line 865 "gitg-date.c"
		GDateTime* _tmp20_ = NULL;
		GMatchInfo* _tmp21_ = NULL;
		GDateTime* _tmp22_ = NULL;
		GDateTime* _tmp23_ = NULL;
#line 291 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp21_ = info;
#line 291 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp22_ = gitg_date_parse_rfc2822 (_tmp21_, &_inner_error_);
#line 291 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp20_ = _tmp22_;
#line 291 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 291 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			g_propagate_error (error, _inner_error_);
#line 291 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_g_match_info_unref0 (info);
#line 291 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			return FALSE;
#line 884 "gitg-date.c"
		}
#line 291 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp23_ = _tmp20_;
#line 291 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp20_ = NULL;
#line 291 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_date_time_unref0 (self->priv->d_datetime);
#line 291 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		self->priv->d_datetime = _tmp23_;
#line 293 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		result = TRUE;
#line 293 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_date_time_unref0 (_tmp20_);
#line 293 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_match_info_unref0 (info);
#line 293 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		return result;
#line 902 "gitg-date.c"
	}
#line 296 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp24_ = g_error_new_literal (GITG_DATE_ERROR, GITG_DATE_ERROR_INVALID_FORMAT, "Invalid date format");
#line 296 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_inner_error_ = _tmp24_;
#line 296 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_propagate_error (error, _inner_error_);
#line 296 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_match_info_unref0 (info);
#line 296 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return FALSE;
#line 914 "gitg-date.c"
}


GitgDate* gitg_date_construct (GType object_type, const gchar* date, GError** error) {
	GitgDate * self = NULL;
	const gchar* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
#line 299 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 301 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = date;
#line 301 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	self = (GitgDate*) g_object_new (object_type, "date-string", _tmp0_, NULL);
#line 302 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_initable_init (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_INITABLE, GInitable), NULL, &_inner_error_);
#line 302 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 302 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		g_propagate_error (error, _inner_error_);
#line 302 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_object_unref0 (self);
#line 302 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		return NULL;
#line 938 "gitg-date.c"
	}
#line 299 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return self;
#line 942 "gitg-date.c"
}


GitgDate* gitg_date_new (const gchar* date, GError** error) {
#line 299 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return gitg_date_construct (GITG_TYPE_DATE, date, error);
#line 949 "gitg-date.c"
}


static gpointer _g_date_time_ref0 (gpointer self) {
#line 307 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 956 "gitg-date.c"
}


gchar* gitg_date_for_display (GitgDate* self) {
	gchar* result = NULL;
	GDateTime* dt = NULL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
	GTimeSpan t = 0LL;
	GDateTime* _tmp2_ = NULL;
	GDateTime* _tmp3_ = NULL;
	GDateTime* _tmp4_ = NULL;
	GTimeSpan _tmp5_ = 0LL;
	GTimeSpan _tmp6_ = 0LL;
	GTimeSpan _tmp7_ = 0LL;
	GDateTime* _tmp42_ = NULL;
	gchar* _tmp43_ = NULL;
#line 305 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 307 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = self->priv->d_datetime;
#line 307 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 307 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	dt = _tmp1_;
#line 308 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp2_ = g_date_time_new_now_local ();
#line 308 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp3_ = _tmp2_;
#line 308 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp4_ = dt;
#line 308 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp5_ = g_date_time_difference (_tmp3_, _tmp4_);
#line 308 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp6_ = _tmp5_;
#line 308 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_date_time_unref0 (_tmp3_);
#line 308 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	t = _tmp6_;
#line 310 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp7_ = t;
#line 310 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	if (((gdouble) _tmp7_) < (G_TIME_SPAN_MINUTE * 29.5)) {
#line 1000 "gitg-date.c"
		gint rounded_minutes = 0;
		GTimeSpan _tmp8_ = 0LL;
		gdouble _tmp9_ = 0.0;
		gint _tmp10_ = 0;
#line 312 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp8_ = t;
#line 312 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp9_ = round ((gdouble) (((gfloat) _tmp8_) / G_TIME_SPAN_MINUTE));
#line 312 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		rounded_minutes = (gint) _tmp9_;
#line 314 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp10_ = rounded_minutes;
#line 314 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		if (_tmp10_ == 0) {
#line 1015 "gitg-date.c"
			const gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
#line 316 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_tmp11_ = _ ("Now");
#line 316 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 316 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			result = _tmp12_;
#line 316 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_g_date_time_unref0 (dt);
#line 316 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			return result;
#line 1028 "gitg-date.c"
		} else {
			gint _tmp13_ = 0;
			const gchar* _tmp14_ = NULL;
			gint _tmp15_ = 0;
			gchar* _tmp16_ = NULL;
#line 320 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_tmp13_ = rounded_minutes;
#line 320 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_tmp14_ = ngettext ("A minute ago", "%d minutes ago", (gulong) _tmp13_);
#line 320 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_tmp15_ = rounded_minutes;
#line 320 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_tmp16_ = g_strdup_printf (_tmp14_, _tmp15_);
#line 320 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			result = _tmp16_;
#line 320 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_g_date_time_unref0 (dt);
#line 320 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			return result;
#line 1048 "gitg-date.c"
		}
	} else {
		GTimeSpan _tmp17_ = 0LL;
#line 323 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp17_ = t;
#line 323 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		if (_tmp17_ < (G_TIME_SPAN_MINUTE * 45)) {
#line 1056 "gitg-date.c"
			const gchar* _tmp18_ = NULL;
			gchar* _tmp19_ = NULL;
#line 325 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_tmp18_ = _ ("Half an hour ago");
#line 325 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_tmp19_ = g_strdup (_tmp18_);
#line 325 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			result = _tmp19_;
#line 325 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_g_date_time_unref0 (dt);
#line 325 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			return result;
#line 1069 "gitg-date.c"
		} else {
			GTimeSpan _tmp20_ = 0LL;
#line 327 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_tmp20_ = t;
#line 327 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			if (((gdouble) _tmp20_) < (G_TIME_SPAN_HOUR * 23.5)) {
#line 1076 "gitg-date.c"
				gint rounded_hours = 0;
				GTimeSpan _tmp21_ = 0LL;
				gdouble _tmp22_ = 0.0;
				gint _tmp23_ = 0;
				const gchar* _tmp24_ = NULL;
				gint _tmp25_ = 0;
				gchar* _tmp26_ = NULL;
#line 329 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp21_ = t;
#line 329 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp22_ = round ((gdouble) (((gfloat) _tmp21_) / G_TIME_SPAN_HOUR));
#line 329 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				rounded_hours = (gint) _tmp22_;
#line 330 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp23_ = rounded_hours;
#line 330 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp24_ = ngettext ("An hour ago", "%d hours ago", (gulong) _tmp23_);
#line 330 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp25_ = rounded_hours;
#line 330 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp26_ = g_strdup_printf (_tmp24_, _tmp25_);
#line 330 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				result = _tmp26_;
#line 330 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_g_date_time_unref0 (dt);
#line 330 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				return result;
#line 1104 "gitg-date.c"
			} else {
				GTimeSpan _tmp27_ = 0LL;
#line 332 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				_tmp27_ = t;
#line 332 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
				if (_tmp27_ < (G_TIME_SPAN_DAY * 7)) {
#line 1111 "gitg-date.c"
					gint rounded_days = 0;
					GTimeSpan _tmp28_ = 0LL;
					gdouble _tmp29_ = 0.0;
					gint _tmp30_ = 0;
					const gchar* _tmp31_ = NULL;
					gint _tmp32_ = 0;
					gchar* _tmp33_ = NULL;
#line 334 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp28_ = t;
#line 334 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp29_ = round ((gdouble) (((gfloat) _tmp28_) / G_TIME_SPAN_DAY));
#line 334 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					rounded_days = (gint) _tmp29_;
#line 335 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp30_ = rounded_days;
#line 335 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp31_ = ngettext ("A day ago", "%d days ago", (gulong) _tmp30_);
#line 335 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp32_ = rounded_days;
#line 335 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp33_ = g_strdup_printf (_tmp31_, _tmp32_);
#line 335 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					result = _tmp33_;
#line 335 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_g_date_time_unref0 (dt);
#line 335 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					return result;
#line 1139 "gitg-date.c"
				} else {
					GDateTime* _tmp34_ = NULL;
					gint _tmp35_ = 0;
					GDateTime* _tmp36_ = NULL;
					GDateTime* _tmp37_ = NULL;
					gint _tmp38_ = 0;
					gboolean _tmp39_ = FALSE;
#line 338 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp34_ = dt;
#line 338 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp35_ = g_date_time_get_year (_tmp34_);
#line 338 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp36_ = g_date_time_new_now_local ();
#line 338 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp37_ = _tmp36_;
#line 338 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp38_ = g_date_time_get_year (_tmp37_);
#line 338 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_tmp39_ = _tmp35_ == _tmp38_;
#line 338 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					_g_date_time_unref0 (_tmp37_);
#line 338 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
					if (_tmp39_) {
#line 1163 "gitg-date.c"
						GDateTime* _tmp40_ = NULL;
						gchar* _tmp41_ = NULL;
#line 340 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
						_tmp40_ = dt;
#line 340 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
						_tmp41_ = g_date_time_format (_tmp40_, "%h %e, %I:%M %P");
#line 340 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
						result = _tmp41_;
#line 340 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
						_g_date_time_unref0 (dt);
#line 340 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
						return result;
#line 1176 "gitg-date.c"
					}
				}
			}
		}
	}
#line 342 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp42_ = dt;
#line 342 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp43_ = g_date_time_format (_tmp42_, "%h %e %Y, %I:%M %P");
#line 342 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	result = _tmp43_;
#line 342 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_date_time_unref0 (dt);
#line 342 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return result;
#line 1192 "gitg-date.c"
}


GitgDate* gitg_date_construct_for_date_time (GType object_type, GDateTime* dt) {
	GitgDate * self = NULL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
#line 345 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_val_if_fail (dt != NULL, NULL);
#line 345 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	self = (GitgDate*) g_object_new (object_type, NULL);
#line 347 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = dt;
#line 347 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 347 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_date_time_unref0 (self->priv->d_datetime);
#line 347 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	self->priv->d_datetime = _tmp1_;
#line 345 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return self;
#line 1214 "gitg-date.c"
}


GitgDate* gitg_date_new_for_date_time (GDateTime* dt) {
#line 345 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return gitg_date_construct_for_date_time (GITG_TYPE_DATE, dt);
#line 1221 "gitg-date.c"
}


GDateTime* gitg_date_parse (const gchar* date, GError** error) {
	GDateTime* result = NULL;
	GitgDate* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GitgDate* _tmp2_ = NULL;
	GitgDate* _tmp3_ = NULL;
	GitgDate* _tmp4_ = NULL;
	GDateTime* _tmp5_ = NULL;
	GDateTime* _tmp6_ = NULL;
	GDateTime* _tmp7_ = NULL;
	GDateTime* _tmp8_ = NULL;
	GError * _inner_error_ = NULL;
#line 350 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp1_ = date;
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp2_ = gitg_date_new (_tmp1_, &_inner_error_);
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = _tmp2_;
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		g_propagate_error (error, _inner_error_);
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		return NULL;
#line 1251 "gitg-date.c"
	}
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp3_ = _tmp0_;
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = NULL;
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp4_ = _tmp3_;
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp5_ = gitg_date_get_date (_tmp4_);
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp6_ = _tmp5_;
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp7_ = _g_date_time_ref0 (_tmp6_);
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp8_ = _tmp7_;
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_object_unref0 (_tmp4_);
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	result = _tmp8_;
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_object_unref0 (_tmp0_);
#line 352 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return result;
#line 1275 "gitg-date.c"
}


const gchar* gitg_date_get_date_string (GitgDate* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 263 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 263 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = self->priv->_date_string;
#line 263 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	result = _tmp0_;
#line 263 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return result;
#line 1290 "gitg-date.c"
}


void gitg_date_set_date_string (GitgDate* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 263 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_if_fail (self != NULL);
#line 263 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = value;
#line 263 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 263 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_free0 (self->priv->_date_string);
#line 263 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	self->priv->_date_string = _tmp1_;
#line 263 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_object_notify ((GObject *) self, "date-string");
#line 1309 "gitg-date.c"
}


GDateTime* gitg_date_get_date (GitgDate* self) {
	GDateTime* result;
	GDateTime* _tmp0_ = NULL;
#line 268 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 268 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = self->priv->d_datetime;
#line 268 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	result = _tmp0_;
#line 268 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	return result;
#line 1324 "gitg-date.c"
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
#line 1314 "/opt/gnome/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1315 "/opt/gnome/share/vala-0.26/vapi/glib-2.0.vapi"
	result = self;
#line 1315 "/opt/gnome/share/vala-0.26/vapi/glib-2.0.vapi"
	return result;
#line 1336 "gitg-date.c"
}


static void gitg_date_class_init (GitgDateClass * klass) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar** _tmp12_ = NULL;
	GError * _inner_error_ = NULL;
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_parent_class = g_type_class_peek_parent (klass);
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_type_class_add_private (klass, sizeof (GitgDatePrivate));
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_date_get_property;
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gitg_date_set_property;
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	G_OBJECT_CLASS (klass)->finalize = gitg_date_finalize;
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_DATE_DATE_STRING, g_param_spec_string ("date-string", "date-string", "date-string", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_DATE_DATE, g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp0_ = g_strdup ("Jan");
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp1_ = g_strdup ("Feb");
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp2_ = g_strdup ("Mar");
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp3_ = g_strdup ("Apr");
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp4_ = g_strdup ("May");
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp5_ = g_strdup ("Jun");
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp6_ = g_strdup ("Jul");
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp7_ = g_strdup ("Aug");
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp8_ = g_strdup ("Sep");
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp9_ = g_strdup ("Oct");
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp10_ = g_strdup ("Nov");
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp11_ = g_strdup ("Dec");
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_ = g_new0 (gchar*, 13 + 1);
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_[0] = NULL;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_[1] = _tmp0_;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_[2] = _tmp1_;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_[3] = _tmp2_;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_[4] = _tmp3_;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_[5] = _tmp4_;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_[6] = _tmp5_;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_[7] = _tmp6_;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_[8] = _tmp7_;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_[9] = _tmp8_;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_[10] = _tmp9_;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_[11] = _tmp10_;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_tmp12_[12] = _tmp11_;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_s_months = _tmp12_;
#line 34 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_s_months_length1 = 13;
#line 1425 "gitg-date.c"
	{
		GRegex* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		GRegex* _tmp16_ = NULL;
		GRegex* _tmp17_ = NULL;
		GRegex* _tmp18_ = NULL;
		GRegex* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		GRegex* _tmp22_ = NULL;
		GRegex* _tmp23_ = NULL;
		GRegex* _tmp24_ = NULL;
		GRegex* _tmp25_ = NULL;
		gchar* _tmp26_ = NULL;
		gchar* _tmp27_ = NULL;
		GRegex* _tmp28_ = NULL;
		GRegex* _tmp29_ = NULL;
		GRegex* _tmp30_ = NULL;
#line 55 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp14_ = g_strconcat ("^\n" \
"			(?<year>[0-9]{4})\n" \
"			(?:\n" \
"				[-.]?(?:\n" \
"					(?<month>[0-9]{2})\n" \
"					(?:\n" \
"						[-.]?(?<day>[0-9]{2})\n" \
"					)?\n" \
"				|\n" \
"					W(?<week>[0-9]{2})\n" \
"					(?:\n" \
"						[-.]?(?<weekday>[0-9])\n" \
"					)?\n" \
"				)\n" \
"				(?:\n" \
"					[T ](?<hour>[0-9]{2})\n" \
"					(?:\n" \
"						:?\n" \
"						(?<minute>[0-9]{2})\n" \
"						(?:\n" \
"							:?\n" \
"							(?<seconds>[0-9]{2})\n" \
"							(?<tz>\n" \
"								(?<tzutc>Z) |\n" \
"								[+-](?<tzhour>[0-9]{2})\n" \
"								(?:\n" \
"									:?\n" \
"									(?<tzminute>[0-9]{2})\n" \
"								)?\n" \
"							)?\n" \
"						)?\n" \
"					)?\n" \
"				)?\n" \
"			)?\n" \
"		", "$", NULL);
#line 55 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp15_ = _tmp14_;
#line 55 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp16_ = g_regex_new (_tmp15_, G_REGEX_EXTENDED, 0, &_inner_error_);
#line 55 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp17_ = _tmp16_;
#line 55 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_free0 (_tmp15_);
#line 55 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp13_ = _tmp17_;
#line 55 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1459 "gitg-date.c"
			goto __catch69_g_error;
		}
#line 55 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp18_ = _tmp13_;
#line 55 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp13_ = NULL;
#line 55 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_regex_unref0 (gitg_date_s_iso8601);
#line 55 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		gitg_date_s_iso8601 = _tmp18_;
#line 91 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp20_ = g_strconcat ("^\n" \
"			(?:\n" \
"				[\\s]*(?<dayofweek>Mon|Tue|Wed|Thu|Fri|Sat|Sun)\n" \
"				,\n" \
"			)?\n" \
"			[\\s]*(?<day>[0-9]{1,2})\n" \
"			[\\s]+\n" \
"				(?<month>Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\n" \
"			[\\s]+\n" \
"				(?<year>[0-9]{4})\n" \
"			[\\s]+\n" \
"				(?<hour>[0-9]{2})\n" \
"				:\n" \
"				(?<minute>[0-9]{2})\n" \
"				(?:\n" \
"					:\n" \
"					(?<seconds>[0-9]{2})\n" \
"				)?\n" \
"			[\\s]+\n" \
"			(?<tz>\n" \
"				[+-]\n" \
"				(?<tzhour>[0-9]{2})\n" \
"				(?<tzminute>[0-9]{2})\n" \
"			)\n" \
"		", "$", NULL);
#line 91 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp21_ = _tmp20_;
#line 91 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp22_ = g_regex_new (_tmp21_, G_REGEX_EXTENDED, 0, &_inner_error_);
#line 91 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp23_ = _tmp22_;
#line 91 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_free0 (_tmp21_);
#line 91 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp19_ = _tmp23_;
#line 91 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 91 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_g_regex_unref0 (_tmp13_);
#line 1486 "gitg-date.c"
			goto __catch69_g_error;
		}
#line 91 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp24_ = _tmp19_;
#line 91 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp19_ = NULL;
#line 91 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_regex_unref0 (gitg_date_s_rfc2822);
#line 91 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		gitg_date_s_rfc2822 = _tmp24_;
#line 117 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp26_ = g_strconcat ("^\n" \
"			@?\n" \
"			(?<timestamp>[0-9]+)\n" \
"			[ ](?<tz>\n" \
"				[+-](?<tzhour>[0-9]{2})\n" \
"				(?:\n" \
"					:?\n" \
"					(?<tzminute>[0-9]{2})?\n" \
"				)\n" \
"			)\n" \
"		", "$", NULL);
#line 117 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp27_ = _tmp26_;
#line 117 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp28_ = g_regex_new (_tmp27_, G_REGEX_EXTENDED, 0, &_inner_error_);
#line 117 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp29_ = _tmp28_;
#line 117 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_free0 (_tmp27_);
#line 117 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp25_ = _tmp29_;
#line 117 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 117 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_g_regex_unref0 (_tmp19_);
#line 117 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
			_g_regex_unref0 (_tmp13_);
#line 1515 "gitg-date.c"
			goto __catch69_g_error;
		}
#line 117 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp30_ = _tmp25_;
#line 117 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp25_ = NULL;
#line 117 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_regex_unref0 (gitg_date_s_internal);
#line 117 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		gitg_date_s_internal = _tmp30_;
#line 52 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_regex_unref0 (_tmp25_);
#line 52 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_regex_unref0 (_tmp19_);
#line 52 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_regex_unref0 (_tmp13_);
#line 1532 "gitg-date.c"
	}
	goto __finally69;
	__catch69_g_error:
	{
		GError* e = NULL;
		GError* _tmp31_ = NULL;
		const gchar* _tmp32_ = NULL;
		const gchar* _tmp33_ = NULL;
		gchar* _tmp34_ = NULL;
		gchar* _tmp35_ = NULL;
#line 52 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		e = _inner_error_;
#line 52 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_inner_error_ = NULL;
#line 132 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp31_ = e;
#line 132 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp32_ = _tmp31_->message;
#line 132 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp33_ = string_to_string (_tmp32_);
#line 132 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp34_ = g_strconcat ("Failed to compile date regex: ", _tmp33_, NULL);
#line 132 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_tmp35_ = _tmp34_;
#line 132 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		g_warning ("gitg-date.vala:132: %s", _tmp35_);
#line 132 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_free0 (_tmp35_);
#line 52 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		_g_error_free0 (e);
#line 1563 "gitg-date.c"
	}
	__finally69:
#line 52 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 52 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 52 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		g_clear_error (&_inner_error_);
#line 1572 "gitg-date.c"
	}
}


static void gitg_date_g_initable_interface_init (GInitableIface * iface) {
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	gitg_date_g_initable_parent_iface = g_type_interface_peek_parent (iface);
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	iface->init = (gboolean (*)(GInitable*, GCancellable*, GError**)) gitg_date_real_init;
#line 1582 "gitg-date.c"
}


static void gitg_date_instance_init (GitgDate * self) {
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	self->priv = GITG_DATE_GET_PRIVATE (self);
#line 1589 "gitg-date.c"
}


static void gitg_date_finalize (GObject* obj) {
	GitgDate * self;
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_DATE, GitgDate);
#line 259 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_date_time_unref0 (self->priv->d_datetime);
#line 261 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	_g_free0 (self->priv->_date_string);
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	G_OBJECT_CLASS (gitg_date_parent_class)->finalize (obj);
#line 1603 "gitg-date.c"
}


GType gitg_date_get_type (void) {
	static volatile gsize gitg_date_type_id__volatile = 0;
	if (g_once_init_enter (&gitg_date_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GitgDateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_date_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgDate), 0, (GInstanceInitFunc) gitg_date_instance_init, NULL };
		static const GInterfaceInfo g_initable_info = { (GInterfaceInitFunc) gitg_date_g_initable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType gitg_date_type_id;
		gitg_date_type_id = g_type_register_static (G_TYPE_OBJECT, "GitgDate", &g_define_type_info, 0);
		g_type_add_interface_static (gitg_date_type_id, G_TYPE_INITABLE, &g_initable_info);
		g_once_init_leave (&gitg_date_type_id__volatile, gitg_date_type_id);
	}
	return gitg_date_type_id__volatile;
}


static void _vala_gitg_date_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GitgDate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_DATE, GitgDate);
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	switch (property_id) {
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		case GITG_DATE_DATE_STRING:
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		g_value_set_string (value, gitg_date_get_date_string (self));
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		break;
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		case GITG_DATE_DATE:
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		g_value_set_boxed (value, gitg_date_get_date (self));
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		break;
#line 1638 "gitg-date.c"
		default:
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		break;
#line 1644 "gitg-date.c"
	}
}


static void _vala_gitg_date_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GitgDate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_DATE, GitgDate);
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
	switch (property_id) {
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		case GITG_DATE_DATE_STRING:
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		gitg_date_set_date_string (self, g_value_get_string (value));
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		break;
#line 1660 "gitg-date.c"
		default:
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/home/jesse/git/gnome/gitg/libgitg/gitg-date.vala"
		break;
#line 1666 "gitg-date.c"
	}
}



